/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { GitlabBranchDtoIEnumerableResponse } from '../../@coscine/model';
// @ts-ignore
import type { GitlabProjectDtoIEnumerableResponse } from '../../@coscine/model';
// @ts-ignore
import type { GitlabProjectDtoResponse } from '../../@coscine/model';
/**
 * ResourceTypeGitLabApi - axios parameter creator
 * @export
 */
export const ResourceTypeGitLabApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ResourceTypesGitlabOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/resource-types/gitlab`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
         * @param {number} gitlabProjectId The ID of the GitLab project.
         * @param {string} domain Domain/Host of the GitLab Provider.
         * @param {string} accessToken GitLab Project or Group Access Token.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllGitlabBranchesForProject: async (gitlabProjectId: number, domain: string, accessToken: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'gitlabProjectId' is not null or undefined
            assertParamExists('getAllGitlabBranchesForProject', 'gitlabProjectId', gitlabProjectId)
            // verify required parameter 'domain' is not null or undefined
            assertParamExists('getAllGitlabBranchesForProject', 'domain', domain)
            // verify required parameter 'accessToken' is not null or undefined
            assertParamExists('getAllGitlabBranchesForProject', 'accessToken', accessToken)
            const localVarPath = `/api/v2/resource-types/gitlab/projects/{gitlabProjectId}/branches`
                .replace(`{${"gitlabProjectId"}}`, encodeURIComponent(String(gitlabProjectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (domain !== undefined) {
                localVarQueryParameter['Domain'] = domain;
            }

            if (accessToken !== undefined) {
                localVarQueryParameter['AccessToken'] = accessToken;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
         * @param {string} domain Domain/Host of the GitLab Provider.
         * @param {string} accessToken GitLab Project or Group Access Token.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllGitlabProjects: async (domain: string, accessToken: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'domain' is not null or undefined
            assertParamExists('getAllGitlabProjects', 'domain', domain)
            // verify required parameter 'accessToken' is not null or undefined
            assertParamExists('getAllGitlabProjects', 'accessToken', accessToken)
            const localVarPath = `/api/v2/resource-types/gitlab/projects`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (domain !== undefined) {
                localVarQueryParameter['Domain'] = domain;
            }

            if (accessToken !== undefined) {
                localVarQueryParameter['AccessToken'] = accessToken;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
         * @param {number} gitlabProjectId The ID of the GitLab project.
         * @param {string} domain Domain/Host of the GitLab Provider.
         * @param {string} accessToken GitLab Project or Group Access Token.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getGitlabProject: async (gitlabProjectId: number, domain: string, accessToken: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'gitlabProjectId' is not null or undefined
            assertParamExists('getGitlabProject', 'gitlabProjectId', gitlabProjectId)
            // verify required parameter 'domain' is not null or undefined
            assertParamExists('getGitlabProject', 'domain', domain)
            // verify required parameter 'accessToken' is not null or undefined
            assertParamExists('getGitlabProject', 'accessToken', accessToken)
            const localVarPath = `/api/v2/resource-types/gitlab/projects/{gitlabProjectId}`
                .replace(`{${"gitlabProjectId"}}`, encodeURIComponent(String(gitlabProjectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (domain !== undefined) {
                localVarQueryParameter['Domain'] = domain;
            }

            if (accessToken !== undefined) {
                localVarQueryParameter['AccessToken'] = accessToken;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ResourceTypeGitLabApi - functional programming interface
 * @export
 */
export const ResourceTypeGitLabApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ResourceTypeGitLabApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ResourceTypesGitlabOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ResourceTypesGitlabOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ResourceTypeGitLabApi.apiV2ResourceTypesGitlabOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
         * @param {number} gitlabProjectId The ID of the GitLab project.
         * @param {string} domain Domain/Host of the GitLab Provider.
         * @param {string} accessToken GitLab Project or Group Access Token.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAllGitlabBranchesForProject(gitlabProjectId: number, domain: string, accessToken: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GitlabBranchDtoIEnumerableResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAllGitlabBranchesForProject(gitlabProjectId, domain, accessToken, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ResourceTypeGitLabApi.getAllGitlabBranchesForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
         * @param {string} domain Domain/Host of the GitLab Provider.
         * @param {string} accessToken GitLab Project or Group Access Token.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAllGitlabProjects(domain: string, accessToken: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GitlabProjectDtoIEnumerableResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAllGitlabProjects(domain, accessToken, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ResourceTypeGitLabApi.getAllGitlabProjects']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
         * @param {number} gitlabProjectId The ID of the GitLab project.
         * @param {string} domain Domain/Host of the GitLab Provider.
         * @param {string} accessToken GitLab Project or Group Access Token.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getGitlabProject(gitlabProjectId: number, domain: string, accessToken: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GitlabProjectDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getGitlabProject(gitlabProjectId, domain, accessToken, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ResourceTypeGitLabApi.getGitlabProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ResourceTypeGitLabApi - factory interface
 * @export
 */
export const ResourceTypeGitLabApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ResourceTypeGitLabApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ResourceTypesGitlabOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ResourceTypesGitlabOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
         * @param {ResourceTypeGitLabApiGetAllGitlabBranchesForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllGitlabBranchesForProject(requestParameters: ResourceTypeGitLabApiGetAllGitlabBranchesForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<GitlabBranchDtoIEnumerableResponse> {
            return localVarFp.getAllGitlabBranchesForProject(requestParameters.gitlabProjectId, requestParameters.domain, requestParameters.accessToken, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
         * @param {ResourceTypeGitLabApiGetAllGitlabProjectsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllGitlabProjects(requestParameters: ResourceTypeGitLabApiGetAllGitlabProjectsRequest, options?: RawAxiosRequestConfig): AxiosPromise<GitlabProjectDtoIEnumerableResponse> {
            return localVarFp.getAllGitlabProjects(requestParameters.domain, requestParameters.accessToken, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
         * @param {ResourceTypeGitLabApiGetGitlabProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getGitlabProject(requestParameters: ResourceTypeGitLabApiGetGitlabProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<GitlabProjectDtoResponse> {
            return localVarFp.getGitlabProject(requestParameters.gitlabProjectId, requestParameters.domain, requestParameters.accessToken, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getAllGitlabBranchesForProject operation in ResourceTypeGitLabApi.
 * @export
 * @interface ResourceTypeGitLabApiGetAllGitlabBranchesForProjectRequest
 */
export interface ResourceTypeGitLabApiGetAllGitlabBranchesForProjectRequest {
    /**
     * The ID of the GitLab project.
     * @type {number}
     * @memberof ResourceTypeGitLabApiGetAllGitlabBranchesForProject
     */
    readonly gitlabProjectId: number

    /**
     * Domain/Host of the GitLab Provider.
     * @type {string}
     * @memberof ResourceTypeGitLabApiGetAllGitlabBranchesForProject
     */
    readonly domain: string

    /**
     * GitLab Project or Group Access Token.
     * @type {string}
     * @memberof ResourceTypeGitLabApiGetAllGitlabBranchesForProject
     */
    readonly accessToken: string
}

/**
 * Request parameters for getAllGitlabProjects operation in ResourceTypeGitLabApi.
 * @export
 * @interface ResourceTypeGitLabApiGetAllGitlabProjectsRequest
 */
export interface ResourceTypeGitLabApiGetAllGitlabProjectsRequest {
    /**
     * Domain/Host of the GitLab Provider.
     * @type {string}
     * @memberof ResourceTypeGitLabApiGetAllGitlabProjects
     */
    readonly domain: string

    /**
     * GitLab Project or Group Access Token.
     * @type {string}
     * @memberof ResourceTypeGitLabApiGetAllGitlabProjects
     */
    readonly accessToken: string
}

/**
 * Request parameters for getGitlabProject operation in ResourceTypeGitLabApi.
 * @export
 * @interface ResourceTypeGitLabApiGetGitlabProjectRequest
 */
export interface ResourceTypeGitLabApiGetGitlabProjectRequest {
    /**
     * The ID of the GitLab project.
     * @type {number}
     * @memberof ResourceTypeGitLabApiGetGitlabProject
     */
    readonly gitlabProjectId: number

    /**
     * Domain/Host of the GitLab Provider.
     * @type {string}
     * @memberof ResourceTypeGitLabApiGetGitlabProject
     */
    readonly domain: string

    /**
     * GitLab Project or Group Access Token.
     * @type {string}
     * @memberof ResourceTypeGitLabApiGetGitlabProject
     */
    readonly accessToken: string
}

/**
 * ResourceTypeGitLabApi - object-oriented interface
 * @export
 * @class ResourceTypeGitLabApi
 * @extends {BaseAPI}
 */
export class ResourceTypeGitLabApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ResourceTypeGitLabApi
     */
    public apiV2ResourceTypesGitlabOptions(options?: RawAxiosRequestConfig) {
        return ResourceTypeGitLabApiFp(this.configuration).apiV2ResourceTypesGitlabOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
     * @param {ResourceTypeGitLabApiGetAllGitlabBranchesForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ResourceTypeGitLabApi
     */
    public getAllGitlabBranchesForProject(requestParameters: ResourceTypeGitLabApiGetAllGitlabBranchesForProjectRequest, options?: RawAxiosRequestConfig) {
        return ResourceTypeGitLabApiFp(this.configuration).getAllGitlabBranchesForProject(requestParameters.gitlabProjectId, requestParameters.domain, requestParameters.accessToken, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
     * @param {ResourceTypeGitLabApiGetAllGitlabProjectsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ResourceTypeGitLabApi
     */
    public getAllGitlabProjects(requestParameters: ResourceTypeGitLabApiGetAllGitlabProjectsRequest, options?: RawAxiosRequestConfig) {
        return ResourceTypeGitLabApiFp(this.configuration).getAllGitlabProjects(requestParameters.domain, requestParameters.accessToken, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
     * @param {ResourceTypeGitLabApiGetGitlabProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ResourceTypeGitLabApi
     */
    public getGitlabProject(requestParameters: ResourceTypeGitLabApiGetGitlabProjectRequest, options?: RawAxiosRequestConfig) {
        return ResourceTypeGitLabApiFp(this.configuration).getGitlabProject(requestParameters.gitlabProjectId, requestParameters.domain, requestParameters.accessToken, options).then((request) => request(this.axios, this.basePath));
    }
}

